Index: uspace/app/tester/Makefile
===================================================================
--- uspace/app/tester/Makefile	(revision 89dcf93c3256fc08164f222f79051a1acaed5a2b)
+++ uspace/app/tester/Makefile	(revision 7218fe6b2a633b85c30cc17b7392712ed1b9163c)
@@ -29,4 +29,5 @@
 
 USPACE_PREFIX = ../..
+
 LIBS = \
 	$(LIBBLOCK_PREFIX)/libblock.a \
Index: uspace/app/tester/float/softfloat1.c
===================================================================
--- uspace/app/tester/float/softfloat1.c	(revision 89dcf93c3256fc08164f222f79051a1acaed5a2b)
+++ uspace/app/tester/float/softfloat1.c	(revision 7218fe6b2a633b85c30cc17b7392712ed1b9163c)
@@ -39,5 +39,5 @@
 #include "../tester.h"
 
-#define OPERANDS  10
+#define OPERANDS   10
 #define PRECISION  10000
 
@@ -56,5 +56,5 @@
     cmptype_t *);
 
-#define NUMBERS	\
+#define NUMBERS \
 	3.5, -2.1, 100.0, 50.0, -1024.0, 0.0, 768.3156, 1080.499999, -600.0, 1.0
 
@@ -63,5 +63,5 @@
 };
 
-static double dop_a[OPERANDS] =	{
+static double dop_a[OPERANDS] = {
 	NUMBERS
 };
@@ -83,34 +83,33 @@
 	if (a < b)
 		return -1;
-	else if (a > b)
+	
+	if (a > b)
 		return 1;
-
+	
 	return 0;
 }
 
-static void
-uint_to_double_template(void *f, unsigned i, cmptype_t *pic, cmptype_t *pisc)
-{
+static void uint_to_double_template(void *f, unsigned i, cmptype_t *pic,
+    cmptype_t *pisc)
+{
+	uint_to_double_op_t op = (uint_to_double_op_t) f;
+	
 	double c;
 	double_t sc;
-
-	uint_to_double_op_t op = (uint_to_double_op_t) f;
-	
 	op(uop_a[i], &c, &sc);
-
+	
 	*pic = (cmptype_t) (c * PRECISION);
 	*pisc = (cmptype_t) (sc.val * PRECISION);
 }
 
-static void
-double_to_uint_template(void *f, unsigned i, cmptype_t *pic, cmptype_t *pisc)
-{
+static void double_to_uint_template(void *f, unsigned i, cmptype_t *pic,
+    cmptype_t *pisc)
+{
+	double_to_uint_op_t op = (double_to_uint_op_t) f;
+	
 	unsigned int c;
 	unsigned int sc;
-
-	double_to_uint_op_t op = (double_to_uint_op_t) f;
-	
 	op(dop_a[i], &c, &sc);
-
+	
 	*pic = (cmptype_t) c;
 	*pisc = (cmptype_t) sc;
@@ -118,37 +117,32 @@
 
 
-static void
-float_template_binary(void *f, unsigned i, unsigned j, cmptype_t *pic,
-    cmptype_t *pisc)
-{
+static void float_template_binary(void *f, unsigned i, unsigned j,
+    cmptype_t *pic, cmptype_t *pisc)
+{
+	float_binary_op_t op = (float_binary_op_t) f;
+	
 	float c;
 	float_t sc;
-
-	float_binary_op_t op = (float_binary_op_t) f;
-	
 	op(fop_a[i], fop_a[j], &c, &sc);
-
+	
 	*pic = (cmptype_t) (c * PRECISION);
 	*pisc = (cmptype_t) (sc.val * PRECISION);
 }
 
-static void
-double_template_binary(void *f, unsigned i, unsigned j, cmptype_t *pic,
-    cmptype_t *pisc)
-{
+static void double_template_binary(void *f, unsigned i, unsigned j,
+    cmptype_t *pic, cmptype_t *pisc)
+{
+	double_binary_op_t op = (double_binary_op_t) f;
+	
 	double c;
 	double_t sc;
-
-	double_binary_op_t op = (double_binary_op_t) f;
-	
 	op(dop_a[i], dop_a[j], &c, &sc);
-
+	
 	*pic = (cmptype_t) (c * PRECISION);
 	*pisc = (cmptype_t) (sc.val * PRECISION);
 }
 
-static void
-double_compare_template(void *f, unsigned i, unsigned j, cmptype_t *pis,
-    cmptype_t *piss)
+static void double_compare_template(void *f, unsigned i, unsigned j,
+    cmptype_t *pis, cmptype_t *piss)
 {
 	double_cmp_op_t op = (double_cmp_op_t) f;
@@ -164,8 +158,8 @@
 		cmptype_t ic;
 		cmptype_t isc;
-
-		template(f, i, &ic, &isc);	
+		
+		template(f, i, &ic, &isc);
 		cmptype_t diff = cmpabs(ic - isc);
-			
+		
 		if (diff != 0) {
 			TPRINTF("i=%u diff=%" PRIdCMPTYPE "\n", i, diff);
@@ -182,9 +176,9 @@
 	
 	for (unsigned int i = 0; i < OPERANDS; i++) {
-		for (unsigned int j = 0; j < OPERANDS; j++) {			
+		for (unsigned int j = 0; j < OPERANDS; j++) {
 			cmptype_t ic;
 			cmptype_t isc;
-
-			template(f, i, j, &ic, &isc);	
+			
+			template(f, i, j, &ic, &isc);
 			cmptype_t diff = cmpabs(ic - isc);
 			
@@ -206,22 +200,22 @@
 }
 
-static void
-double_to_uint_operator(double a, unsigned int *pc, unsigned int *psc)
-{
-	double_t sa;
-
-	sa.val = a;
-
+static void double_to_uint_operator(double a, unsigned int *pc,
+    unsigned int *psc)
+{
+	double_t sa;
+	
+	sa.val = a;
+	
 	*pc = (unsigned int) a;
 	*psc = double_to_uint(sa.data);
 }
 
-static void
-double_to_int_operator(double a, unsigned int *pc, unsigned int *psc)
-{
-	double_t sa;
-
-	sa.val = a;
-
+static void double_to_int_operator(double a, unsigned int *pc,
+    unsigned int *psc)
+{
+	double_t sa;
+	
+	sa.val = a;
+	
 	*pc = (int) a;
 	*psc = double_to_int(sa.data);
@@ -237,7 +231,8 @@
 	sa.val = a;
 	sb.val = b;
-	if (sa.data.parts.sign == sb.data.parts.sign)
+	
+	if (sa.data.parts.sign == sb.data.parts.sign) {
 		psc->data = add_float(sa.data, sb.data);
-	else if (sa.data.parts.sign) {
+	} else if (sa.data.parts.sign) {
 		sa.data.parts.sign = 0;
 		psc->data = sub_float(sb.data, sa.data);
@@ -267,5 +262,5 @@
 		return;
 	}
-
+	
 	*pc = a / b;
 	
@@ -287,7 +282,8 @@
 	sa.val = a;
 	sb.val = b;
-	if (sa.data.parts.sign == sb.data.parts.sign)
+	
+	if (sa.data.parts.sign == sb.data.parts.sign) {
 		psc->data = add_double(sa.data, sb.data);
-	else if (sa.data.parts.sign) {
+	} else if (sa.data.parts.sign) {
 		sa.data.parts.sign = 0;
 		psc->data = sub_double(sb.data, sa.data);
@@ -317,5 +313,5 @@
 		return;
 	}
-
+	
 	*pc = a / b;
 	
@@ -328,15 +324,15 @@
 }
 
-static void
-double_cmp_operator(double a, double b, cmptype_t *pis, cmptype_t *piss)
+static void double_cmp_operator(double a, double b, cmptype_t *pis,
+    cmptype_t *piss)
 {
 	*pis = dcmp(a, b);
-
+	
 	double_t sa;
 	double_t sb;
-
-	sa.val = a;
-	sb.val = b;
-
+	
+	sa.val = a;
+	sb.val = b;
+	
 	if (is_double_lt(sa.data, sb.data))
 		*piss = -1;
@@ -352,33 +348,40 @@
 {
 	const char *err = NULL;
-
+	
 	if (!test_template_binary(float_template_binary, float_add_operator)) {
 		err = "Float addition failed";
 		TPRINTF("%s\n", err);
 	}
+	
 	if (!test_template_binary(float_template_binary, float_mul_operator)) {
 		err = "Float multiplication failed";
 		TPRINTF("%s\n", err);
 	}
+	
 	if (!test_template_binary(float_template_binary, float_div_operator)) {
 		err = "Float division failed";
 		TPRINTF("%s\n", err);
 	}
+	
 	if (!test_template_binary(double_template_binary, double_add_operator)) {
 		err = "Double addition failed";
 		TPRINTF("%s\n", err);
 	}
+	
 	if (!test_template_binary(double_template_binary, double_mul_operator)) {
 		err = "Double multiplication failed";
 		TPRINTF("%s\n", err);
 	}
+	
 	if (!test_template_binary(double_template_binary, double_div_operator)) {
 		err = "Double division failed";
 		TPRINTF("%s\n", err);
 	}
+	
 	if (!test_template_binary(double_compare_template, double_cmp_operator)) {
 		err = "Double comparison failed";
 		TPRINTF("%s\n", err);
 	}
+	
 	if (!test_template_unary(uint_to_double_template,
 	    uint_to_double_operator)) {
@@ -386,4 +389,5 @@
 		TPRINTF("%s\n", err);
 	}
+	
 	if (!test_template_unary(double_to_uint_template,
 	    double_to_uint_operator)) {
@@ -391,4 +395,5 @@
 		TPRINTF("%s\n", err);
 	}
+	
 	if (!test_template_unary(double_to_uint_template,
 	    double_to_int_operator)) {
@@ -399,3 +404,2 @@
 	return err;
 }
-
Index: uspace/app/vdemo/Makefile
===================================================================
--- uspace/app/vdemo/Makefile	(revision 89dcf93c3256fc08164f222f79051a1acaed5a2b)
+++ uspace/app/vdemo/Makefile	(revision 7218fe6b2a633b85c30cc17b7392712ed1b9163c)
@@ -28,8 +28,16 @@
 
 USPACE_PREFIX = ../..
-LIBS = $(LIBGUI_PREFIX)/libgui.a $(LIBDRAW_PREFIX)/libdraw.a \
-	$(LIBSOFTREND_PREFIX)/libsoftrend.a $(LIBSOFTFLOAT_PREFIX)/libsoftfloat.a
-EXTRA_CFLAGS += -I$(LIBGUI_PREFIX) -I$(LIBDRAW_PREFIX) \
+
+LIBS = \
+	$(LIBGUI_PREFIX)/libgui.a \
+	$(LIBDRAW_PREFIX)/libdraw.a \
+	$(LIBSOFTREND_PREFIX)/libsoftrend.a \
+	$(LIBSOFTFLOAT_PREFIX)/libsoftfloat.a
+
+EXTRA_CFLAGS += \
+	-I$(LIBGUI_PREFIX) \
+	-I$(LIBDRAW_PREFIX) \
 	-I$(LIBSOFTREND_PREFIX)
+
 BINARY = vdemo
 
Index: uspace/app/viewer/Makefile
===================================================================
--- uspace/app/viewer/Makefile	(revision 89dcf93c3256fc08164f222f79051a1acaed5a2b)
+++ uspace/app/viewer/Makefile	(revision 7218fe6b2a633b85c30cc17b7392712ed1b9163c)
@@ -28,8 +28,16 @@
 
 USPACE_PREFIX = ../..
-LIBS = $(LIBGUI_PREFIX)/libgui.a $(LIBDRAW_PREFIX)/libdraw.a \
-	$(LIBSOFTREND_PREFIX)/libsoftrend.a $(LIBSOFTFLOAT_PREFIX)/libsoftfloat.a
-EXTRA_CFLAGS += -I$(LIBGUI_PREFIX) -I$(LIBDRAW_PREFIX) \
+
+LIBS = \
+	$(LIBGUI_PREFIX)/libgui.a \
+	$(LIBDRAW_PREFIX)/libdraw.a \
+	$(LIBSOFTREND_PREFIX)/libsoftrend.a \
+	$(LIBSOFTFLOAT_PREFIX)/libsoftfloat.a
+
+EXTRA_CFLAGS += \
+	-I$(LIBGUI_PREFIX) \
+	-I$(LIBDRAW_PREFIX) \
 	-I$(LIBSOFTREND_PREFIX)
+
 BINARY = viewer
 
Index: uspace/app/vlaunch/Makefile
===================================================================
--- uspace/app/vlaunch/Makefile	(revision 89dcf93c3256fc08164f222f79051a1acaed5a2b)
+++ uspace/app/vlaunch/Makefile	(revision 7218fe6b2a633b85c30cc17b7392712ed1b9163c)
@@ -28,8 +28,16 @@
 
 USPACE_PREFIX = ../..
-LIBS = $(LIBGUI_PREFIX)/libgui.a $(LIBDRAW_PREFIX)/libdraw.a \
-	$(LIBSOFTREND_PREFIX)/libsoftrend.a $(LIBSOFTFLOAT_PREFIX)/libsoftfloat.a
-EXTRA_CFLAGS += -I$(LIBGUI_PREFIX) -I$(LIBDRAW_PREFIX) \
+
+LIBS = \
+	$(LIBGUI_PREFIX)/libgui.a \
+	$(LIBDRAW_PREFIX)/libdraw.a \
+	$(LIBSOFTREND_PREFIX)/libsoftrend.a \
+	$(LIBSOFTFLOAT_PREFIX)/libsoftfloat.a
+
+EXTRA_CFLAGS += \
+	-I$(LIBGUI_PREFIX) \
+	-I$(LIBDRAW_PREFIX) \
 	-I$(LIBSOFTREND_PREFIX)
+
 BINARY = vlaunch
 
Index: uspace/app/vterm/Makefile
===================================================================
--- uspace/app/vterm/Makefile	(revision 89dcf93c3256fc08164f222f79051a1acaed5a2b)
+++ uspace/app/vterm/Makefile	(revision 7218fe6b2a633b85c30cc17b7392712ed1b9163c)
@@ -28,9 +28,18 @@
 
 USPACE_PREFIX = ../..
-LIBS = $(LIBGUI_PREFIX)/libgui.a $(LIBDRAW_PREFIX)/libdraw.a \
-	$(LIBSOFTREND_PREFIX)/libsoftrend.a $(LIBGRAPH_PREFIX)/libgraph.a \
+
+LIBS = \
+	$(LIBGUI_PREFIX)/libgui.a \
+	$(LIBDRAW_PREFIX)/libdraw.a \
+	$(LIBSOFTREND_PREFIX)/libsoftrend.a \
+	$(LIBGRAPH_PREFIX)/libgraph.a \
 	$(LIBSOFTFLOAT_PREFIX)/libsoftfloat.a
-EXTRA_CFLAGS += -I$(LIBGUI_PREFIX) -I$(LIBDRAW_PREFIX) \
-	-I$(LIBSOFTREND_PREFIX) -I$(LIBGRAPH_PREFIX)
+
+EXTRA_CFLAGS += \
+	-I$(LIBGUI_PREFIX) \
+	-I$(LIBDRAW_PREFIX) \
+	-I$(LIBSOFTREND_PREFIX) \
+	-I$(LIBGRAPH_PREFIX)
+
 BINARY = vterm
 
Index: uspace/lib/c/Makefile
===================================================================
--- uspace/lib/c/Makefile	(revision 89dcf93c3256fc08164f222f79051a1acaed5a2b)
+++ uspace/lib/c/Makefile	(revision 7218fe6b2a633b85c30cc17b7392712ed1b9163c)
@@ -31,9 +31,6 @@
 ROOT_PATH = $(USPACE_PREFIX)/..
 
-COMMON_MAKEFILE = $(ROOT_PATH)/Makefile.common
-COMMON_HEADER = $(ROOT_PATH)/common.h
+CONFIG_MAKEFILE = $(ROOT_PATH)/Makefile.config
 COMMON_HEADER_ARCH = arch/$(UARCH)/include/libarch/common.h
-
-CONFIG_MAKEFILE = $(ROOT_PATH)/Makefile.config
 
 LINKER_SCRIPTS = \
@@ -50,6 +47,4 @@
 LSONAME = libc.so0
 
-
--include $(COMMON_MAKEFILE)
 -include $(CONFIG_MAKEFILE)
 -include arch/$(UARCH)/Makefile.inc
@@ -160,5 +155,4 @@
 include $(USPACE_PREFIX)/Makefile.common
 
-
 $(LIBC_PREFIX)/arch/$(UARCH)/_link.ld: $(LIBC_PREFIX)/arch/$(UARCH)/_link.ld.in
 	$(CC) $(DEFS) $(CFLAGS) -DLIBC_PATH=$(CURDIR) -E -x c $< | grep -v "^\#" > $@
Index: uspace/lib/c/arch/arm32/Makefile.common
===================================================================
--- uspace/lib/c/arch/arm32/Makefile.common	(revision 89dcf93c3256fc08164f222f79051a1acaed5a2b)
+++ uspace/lib/c/arch/arm32/Makefile.common	(revision 7218fe6b2a633b85c30cc17b7392712ed1b9163c)
@@ -31,7 +31,7 @@
 
 ifeq ($(CONFIG_FPU),y)
-GCC_CFLAGS += -mfloat-abi=hard
+	GCC_CFLAGS += -mfloat-abi=hard
 else
-BASE_LIBS += $(LIBSOFTFLOAT_PREFIX)/libsoftfloat.a
+	BASE_LIBS += $(LIBSOFTFLOAT_PREFIX)/libsoftfloat.a
 endif
 
Index: uspace/srv/loader/Makefile
===================================================================
--- uspace/srv/loader/Makefile	(revision 89dcf93c3256fc08164f222f79051a1acaed5a2b)
+++ uspace/srv/loader/Makefile	(revision 7218fe6b2a633b85c30cc17b7392712ed1b9163c)
@@ -29,11 +29,4 @@
 
 USPACE_PREFIX = ../..
-ROOT_PATH = $(USPACE_PREFIX)/..
-
-COMMON_MAKEFILE = $(ROOT_PATH)/Makefile.common
-CONFIG_MAKEFILE = $(ROOT_PATH)/Makefile.config
-
--include $(COMMON_MAKEFILE)
--include $(CONFIG_MAKEFILE)
 
 LINKER_SCRIPT = $(LIBC_PREFIX)/arch/$(UARCH)/_link-loader.ld