Index: uspace/app/blkdump/blkdump.c
===================================================================
--- uspace/app/blkdump/blkdump.c	(revision e299dbea7222619405338e2251a7e729a9b1e37a)
+++ uspace/app/blkdump/blkdump.c	(revision 7354b5e275cfd7f15773c38db318e1fa938eab6e)
@@ -46,5 +46,5 @@
 #include <byteorder.h>
 #include <scsi/mmc.h>
-#include <sys/typefmt.h>
+#include <offset.h>
 #include <inttypes.h>
 #include <errno.h>
Index: uspace/app/bnchmark/bnchmark.c
===================================================================
--- uspace/app/bnchmark/bnchmark.c	(revision e299dbea7222619405338e2251a7e729a9b1e37a)
+++ uspace/app/bnchmark/bnchmark.c	(revision 7354b5e275cfd7f15773c38db318e1fa938eab6e)
@@ -44,5 +44,4 @@
 #include <loc.h>
 #include <byteorder.h>
-#include <sys/typefmt.h>
 #include <inttypes.h>
 #include <errno.h>
Index: uspace/app/devctl/devctl.c
===================================================================
--- uspace/app/devctl/devctl.c	(revision e299dbea7222619405338e2251a7e729a9b1e37a)
+++ uspace/app/devctl/devctl.c	(revision 7354b5e275cfd7f15773c38db318e1fa938eab6e)
@@ -39,5 +39,4 @@
 #include <stdlib.h>
 #include <str_error.h>
-#include <sys/typefmt.h>
 
 #define NAME "devctl"
Index: uspace/app/loc/loc.c
===================================================================
--- uspace/app/loc/loc.c	(revision e299dbea7222619405338e2251a7e729a9b1e37a)
+++ uspace/app/loc/loc.c	(revision 7354b5e275cfd7f15773c38db318e1fa938eab6e)
@@ -38,6 +38,6 @@
 #include <stdlib.h>
 #include <stdint.h>
+#include <inttypes.h>
 #include <str.h>
-#include <sys/typefmt.h>
 
 #define NAME "loc"
Index: uspace/app/mkexfat/mkexfat.c
===================================================================
--- uspace/app/mkexfat/mkexfat.c	(revision e299dbea7222619405338e2251a7e729a9b1e37a)
+++ uspace/app/mkexfat/mkexfat.c	(revision 7354b5e275cfd7f15773c38db318e1fa938eab6e)
@@ -46,5 +46,4 @@
 #include <byteorder.h>
 #include <align.h>
-#include <sys/typefmt.h>
 #include <str.h>
 #include <getopt.h>
Index: uspace/app/mkfat/mkfat.c
===================================================================
--- uspace/app/mkfat/mkfat.c	(revision e299dbea7222619405338e2251a7e729a9b1e37a)
+++ uspace/app/mkfat/mkfat.c	(revision 7354b5e275cfd7f15773c38db318e1fa938eab6e)
@@ -45,5 +45,4 @@
 #include <loc.h>
 #include <byteorder.h>
-#include <sys/typefmt.h>
 #include <inttypes.h>
 #include <errno.h>
Index: uspace/app/mkmfs/mkmfs.c
===================================================================
--- uspace/app/mkmfs/mkmfs.c	(revision e299dbea7222619405338e2251a7e729a9b1e37a)
+++ uspace/app/mkmfs/mkmfs.c	(revision 7354b5e275cfd7f15773c38db318e1fa938eab6e)
@@ -41,5 +41,4 @@
 #include <block.h>
 #include <errno.h>
-#include <sys/typefmt.h>
 #include <inttypes.h>
 #include <getopt.h>
Index: uspace/app/taskdump/taskdump.c
===================================================================
--- uspace/app/taskdump/taskdump.c	(revision e299dbea7222619405338e2251a7e729a9b1e37a)
+++ uspace/app/taskdump/taskdump.c	(revision 7354b5e275cfd7f15773c38db318e1fa938eab6e)
@@ -44,5 +44,4 @@
 #include <task.h>
 #include <as.h>
-#include <sys/typefmt.h>
 #include <libarch/istate.h>
 #include <macros.h>
Index: uspace/app/testread/testread.c
===================================================================
--- uspace/app/testread/testread.c	(revision e299dbea7222619405338e2251a7e729a9b1e37a)
+++ uspace/app/testread/testread.c	(revision 7354b5e275cfd7f15773c38db318e1fa938eab6e)
@@ -54,5 +54,4 @@
 #include <loc.h>
 #include <byteorder.h>
-#include <sys/typefmt.h>
 #include <inttypes.h>
 #include <errno.h>
Index: uspace/app/trace/ipcp.c
===================================================================
--- uspace/app/trace/ipcp.c	(revision e299dbea7222619405338e2251a7e729a9b1e37a)
+++ uspace/app/trace/ipcp.c	(revision 7354b5e275cfd7f15773c38db318e1fa938eab6e)
@@ -35,6 +35,6 @@
 #include <stdio.h>
 #include <stdlib.h>
+#include <inttypes.h>
 #include <adt/hash_table.h>
-#include <sys/typefmt.h>
 #include <abi/ipc/methods.h>
 #include <macros.h>
Index: uspace/app/trace/trace.c
===================================================================
--- uspace/app/trace/trace.c	(revision e299dbea7222619405338e2251a7e729a9b1e37a)
+++ uspace/app/trace/trace.c	(revision 7354b5e275cfd7f15773c38db318e1fa938eab6e)
@@ -38,4 +38,5 @@
 #include <stdint.h>
 #include <stddef.h>
+#include <inttypes.h>
 #include <fibril.h>
 #include <errno.h>
@@ -49,5 +50,4 @@
 #include <io/keycode.h>
 #include <fibril_synch.h>
-#include <sys/typefmt.h>
 #include <vfs/vfs.h>
 
Index: uspace/lib/block/block.c
===================================================================
--- uspace/lib/block/block.c	(revision e299dbea7222619405338e2251a7e729a9b1e37a)
+++ uspace/lib/block/block.c	(revision 7354b5e275cfd7f15773c38db318e1fa938eab6e)
@@ -51,6 +51,7 @@
 #include <malloc.h>
 #include <stdio.h>
-#include <sys/typefmt.h>
 #include <stacktrace.h>
+#include <offset.h>
+#include <inttypes.h>
 #include "block.h"
 
Index: uspace/lib/c/include/offset.h
===================================================================
--- uspace/lib/c/include/offset.h	(revision e299dbea7222619405338e2251a7e729a9b1e37a)
+++ uspace/lib/c/include/offset.h	(revision 7354b5e275cfd7f15773c38db318e1fa938eab6e)
@@ -36,5 +36,4 @@
 #define LIBC_OFFSET_H_
 
-#include <libarch/types.h>
 #include <stdint.h>
 
@@ -47,4 +46,9 @@
 #define AOFF64_MAX  UINT64_MAX
 
+/* off64_t, aoff64_t */
+#define PRIdOFF64 PRId64
+#define PRIuOFF64 PRIu64
+#define PRIxOFF64 PRIx64
+#define PRIXOFF64 PRIX64
 
 /** Relative offset */
Index: uspace/lib/c/include/sys/typefmt.h
===================================================================
--- uspace/lib/c/include/sys/typefmt.h	(revision e299dbea7222619405338e2251a7e729a9b1e37a)
+++ 	(revision )
@@ -1,50 +1,0 @@
-/*
- * Copyright (c) 2010 Jiri Svoboda
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * - Redistributions of source code must retain the above copyright
- *   notice, this list of conditions and the following disclaimer.
- * - Redistributions in binary form must reproduce the above copyright
- *   notice, this list of conditions and the following disclaimer in the
- *   documentation and/or other materials provided with the distribution.
- * - The name of the author may not be used to endorse or promote products
- *   derived from this software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
- * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
- * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
- * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
- * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
- * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
- * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
- * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
- * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
- * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- */
-
-/** @addtogroup libc
- * @{
- */
-/** @file Formatting macros for types from sys/types.h and some other
- * system types.
- */
-
-#ifndef LIBC_SYS_TYPEFMT_H_
-#define LIBC_SYS_TYPEFMT_H_
-
-#include <inttypes.h>
-
-/* off64_t, aoff64_t */
-#define PRIdOFF64 PRId64
-#define PRIuOFF64 PRIu64
-#define PRIxOFF64 PRIx64
-#define PRIXOFF64 PRIX64
-
-#endif
-
-/** @}
- */
Index: uspace/lib/posix/include/posix/sys/types.h
===================================================================
--- uspace/lib/posix/include/posix/sys/types.h	(revision e299dbea7222619405338e2251a7e729a9b1e37a)
+++ uspace/lib/posix/include/posix/sys/types.h	(revision 7354b5e275cfd7f15773c38db318e1fa938eab6e)
@@ -44,4 +44,6 @@
 #include "libc/sys/time.h"
 
+#include <libarch/types.h>
+
 typedef unsigned int __POSIX_DEF__(ino_t);
 typedef unsigned int __POSIX_DEF__(nlink_t);
Index: uspace/srv/bd/file_bd/file_bd.c
===================================================================
--- uspace/srv/bd/file_bd/file_bd.c	(revision e299dbea7222619405338e2251a7e729a9b1e37a)
+++ uspace/srv/bd/file_bd/file_bd.c	(revision 7354b5e275cfd7f15773c38db318e1fa938eab6e)
@@ -47,5 +47,4 @@
 #include <stddef.h>
 #include <stdint.h>
-#include <sys/typefmt.h>
 #include <errno.h>
 #include <stdbool.h>
Index: uspace/srv/hid/input/ctl/kbdev.c
===================================================================
--- uspace/srv/hid/input/ctl/kbdev.c	(revision e299dbea7222619405338e2251a7e729a9b1e37a)
+++ uspace/srv/hid/input/ctl/kbdev.c	(revision 7354b5e275cfd7f15773c38db318e1fa938eab6e)
@@ -45,5 +45,4 @@
 #include <stdlib.h>
 #include <vfs/vfs_sess.h>
-#include <sys/typefmt.h>
 #include "../gsp.h"
 #include "../input.h"
Index: uspace/srv/hid/input/proto/mousedev.c
===================================================================
--- uspace/srv/hid/input/proto/mousedev.c	(revision e299dbea7222619405338e2251a7e729a9b1e37a)
+++ uspace/srv/hid/input/proto/mousedev.c	(revision 7354b5e275cfd7f15773c38db318e1fa938eab6e)
@@ -43,5 +43,4 @@
 #include <ipc/mouseev.h>
 #include <loc.h>
-#include <sys/typefmt.h>
 #include "../mouse.h"
 #include "../mouse_port.h"
Index: uspace/srv/taskmon/taskmon.c
===================================================================
--- uspace/srv/taskmon/taskmon.c	(revision e299dbea7222619405338e2251a7e729a9b1e37a)
+++ uspace/srv/taskmon/taskmon.c	(revision 7354b5e275cfd7f15773c38db318e1fa938eab6e)
@@ -38,5 +38,4 @@
 #include <async.h>
 #include <ipc/services.h>
-#include <sys/typefmt.h>
 #include <task.h>
 #include <ipc/corecfg.h>